/*
 * Copyright Staffan Gimåker 2007-2008, 2010.
 *
 * ---
 *
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PEEKABOT_RENDERER_MESH_VISITOR_HH_INCLUDED
#define PEEKABOT_RENDERER_MESH_VISITOR_HH_INCLUDED


namespace peekabot
{
    namespace renderer
    {
        class TriMesh;
        class LineMesh;
        class PointMesh;
        class LineStripMesh;

        class MeshVisitor
        {
        public:
            virtual ~MeshVisitor() {}

            virtual void visit(TriMesh &) throw() = 0;

            virtual void visit(LineMesh &) throw() = 0;

            virtual void visit(PointMesh &) throw() = 0;

            virtual void visit(LineStripMesh &) throw() = 0;
        };

    }
}


#endif // PEEKABOT_RENDERER_MESH_VISITOR_HH_INCLUDED
