/*
 * Copyright Staffan Gimåker 2008-2009.
 *
 * ---
 *
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PEEKABOT_RENDERER_DUMMY_HH_INCLUDED
#define PEEKABOT_RENDERER_DUMMY_HH_INCLUDED


#include "../ObjectEntity.hh"


namespace peekabot
{
    namespace renderer
    {
        /**
         * \brief A dummy entity that is used for objects that do not have a
         * graphical representation but still need to be represented in the
         * renderer, to e.g. have a tripod drawn when selected.
         */
        class Dummy : public ObjectEntity
        {
        public:
            virtual void get_renderables(PrepareRenderContext &context) const {}
        };
    }
}


#endif // PEEKABOT_RENDERER_DUMMY_HH_INCLUDED
